QuantLib: CashFlows Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

List of all members
CashFlows Class Reference

cashflow-analysis functions More...

`#include <ql/cashflows/cashflows.hpp>`

## Static Public Member Functions
Date functions
static Date | startDate (const Leg &leg)
static Date | maturityDate (const Leg &leg)
static bool | isExpired (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
CashFlow functions
static Leg::const_reverse_iterator | previousCashFlow (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
| the last cashflow paying before or at the given date
static Leg::const_iterator | nextCashFlow (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
| the first cashflow paying after the given date
static Date | previousCashFlowDate (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Date | nextCashFlowDate (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Real | previousCashFlowAmount (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Real | nextCashFlowAmount (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
Coupon inspectors
static Rate | previousCouponRate (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Rate | nextCouponRate (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Real | nominal (const Leg &leg, bool includeSettlementDateFlows, Date settlDate=Date())
static Date | accrualStartDate (const Leg &leg, bool includeSettlementDateFlows, Date settlDate=Date())
static Date | accrualEndDate (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Date | referencePeriodStart (const Leg &leg, bool includeSettlementDateFlows, Date settlDate=Date())
static Date | referencePeriodEnd (const Leg &leg, bool includeSettlementDateFlows, Date settlDate=Date())
static Time | accrualPeriod (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Date::serial_type | accrualDays (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Time | accruedPeriod (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Date::serial_type | accruedDays (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
static Real | accruedAmount (const Leg &leg, bool includeSettlementDateFlows, Date settlementDate=Date())
YieldTermStructure functions
static Real | npv (const Leg &leg, const YieldTermStructure &discountCurve, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| NPV of the cash flows. More...
static Real | bps (const Leg &leg, const YieldTermStructure &discountCurve, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| Basis-point sensitivity of the cash flows. More...
static void | npvbps (const Leg &leg, const YieldTermStructure &discountCurve, bool includeSettlementDateFlows, Date settlementDate, Date npvDate, Real &npv, Real &bps)
| NPV and BPS of the cash flows. More...
static Rate | atmRate (const Leg &leg, const YieldTermStructure &discountCurve, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date(), Real npv=Null< Real >())
| At-the-money rate of the cash flows. More...
Yield (a.k.a. Internal Rate of Return, i.e. IRR) functions
static Real | npv (const Leg &leg, const InterestRate &yield, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| NPV of the cash flows. More...
static Real | npv (const Leg &leg, Rate yield, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
static Real | bps (const Leg &leg, const InterestRate &yield, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| Basis-point sensitivity of the cash flows. More...
static Real | bps (const Leg &leg, Rate yield, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
static Rate | yield (const Leg &leg, Real npv, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date(), Real accuracy=1.0e-10, Size maxIterations=100, Rate guess=0.05)
| Implied internal rate of return. More...
template<typename Solver >
static Rate | yield (const Solver &solver, const Leg &leg, Real npv, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date(), Real accuracy=1.0e-10, Rate guess=0.05)
static Time | duration (const Leg &leg, const InterestRate &yield, Duration::Type type, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| Cash-flow duration. More...
static Time | duration (const Leg &leg, Rate yield, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, Duration::Type type, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
static Real | convexity (const Leg &leg, const InterestRate &yield, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| Cash-flow convexity. More...
static Real | convexity (const Leg &leg, Rate yield, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
static Real | basisPointValue (const Leg &leg, const InterestRate &yield, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| Basis-point value. More...
static Real | basisPointValue (const Leg &leg, Rate yield, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
static Real | yieldValueBasisPoint (const Leg &leg, const InterestRate &yield, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| Yield value of a basis point. More...
static Real | yieldValueBasisPoint (const Leg &leg, Rate yield, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
Z-spread functions
static Real | npv (const Leg &leg, const ext::shared_ptr< YieldTermStructure > &discount, Spread zSpread, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date())
| NPV of the cash flows. More...
static Spread | zSpread (const Leg &leg, Real npv, const ext::shared_ptr< YieldTermStructure > &, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date(), Real accuracy=1.0e-10, Size maxIterations=100, Rate guess=0.0)
| implied Z-spread.
static Spread | zSpread (const Leg &leg, const ext::shared_ptr< YieldTermStructure > &d, Real npv, const DayCounter &dayCounter, Compounding compounding, Frequency frequency, bool includeSettlementDateFlows, Date settlementDate=Date(), Date npvDate=Date(), Real accuracy=1.0e-10, Size maxIterations=100, Rate guess=0.0)
| deprecated implied Z-spread.

## Detailed Description

cashflow-analysis functions

## Member Function Documentation

## ◆ npv() [1/3]

static Real npv | ( | const Leg & | leg,
|  | const YieldTermStructure & | discountCurve,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

NPV of the cash flows.

The NPV is the sum of the cash flows, each discounted according to the given term structure.

## ◆ bps() [1/2]

static Real bps | ( | const Leg & | leg,
|  | const YieldTermStructure & | discountCurve,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

Basis-point sensitivity of the cash flows.

The result is the change in NPV due to a uniform 1-basis-point change in the rate paid by the cash flows. The change for each coupon is discounted according to the given term structure.

## ◆ npvbps()

static void npvbps | ( | const Leg & | leg,
|  | const YieldTermStructure & | discountCurve,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate,
|  | Date | npvDate,
|  | Real & | npv,
|  | Real & | bps
| ) |  |
| static

NPV and BPS of the cash flows.

The NPV and BPS of the cash flows calculated together for performance reason

## ◆ atmRate()

static Rate atmRate | ( | const Leg & | leg,
|  | const YieldTermStructure & | discountCurve,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`,
|  | Real | npv = `Null< Real >()`
| ) |  |
| static

At-the-money rate of the cash flows.

The result is the fixed rate for which a fixed rate cash flow vector, equivalent to the input vector, has the required NPV according to the given term structure. If the required NPV is not given, the input cash flow vector's NPV is used instead.

## ◆ npv() [2/3]

static Real npv | ( | const Leg & | leg,
|  | const InterestRate & | yield,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

NPV of the cash flows.

The IRR is the interest rate at which the NPV of the cash flows equals the dirty price.

The NPV is the sum of the cash flows, each discounted according to the given constant interest rate. The result is affected by the choice of the interest-rate compounding and the relative frequency and day counter.

## ◆ bps() [2/2]

static Real bps | ( | const Leg & | leg,
|  | const InterestRate & | yield,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

Basis-point sensitivity of the cash flows.

The result is the change in NPV due to a uniform 1-basis-point change in the rate paid by the cash flows. The change for each coupon is discounted according to the given constant interest rate. The result is affected by the choice of the interest-rate compounding and the relative frequency and day counter.

## ◆ yield()

static Rate yield | ( | const Leg & | leg,
|  | Real | npv,
|  | const DayCounter & | dayCounter,
|  | Compounding | compounding,
|  | Frequency | frequency,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`,
|  | Real | accuracy = `1.0e-10`,
|  | Size | maxIterations = `100`,
|  | Rate | guess = `0.05`
| ) |  |
| static

Implied internal rate of return.

The function verifies the theoretical existence of an IRR and numerically establishes the IRR to the desired precision.

## ◆ duration()

static Time duration | ( | const Leg & | leg,
|  | const InterestRate & | yield,
|  | Duration::Type | type,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

Cash-flow duration.

The simple duration of a string of cash flows is defined as

\[ D_{\mathrm{simple}} = \frac{\sum t_i c_i B(t_i)}{\sum c_i B(t_i)} \]

where \( c_i \) is the amount of the \( i \)-th cash flow, \( t_i \) is its payment time, and \( B(t_i) \) is the corresponding discount according to the passed yield.

The modified duration is defined as

\[ D_{\mathrm{modified}} = -\frac{1}{P} \frac{\partial P}{\partial y} \]

where \( P \) is the present value of the cash flows according to the given IRR \( y \).

The Macaulay duration is defined for a compounded IRR as

\[ D_{\mathrm{Macaulay}} = \left( 1 + \frac{y}{N} \right) D_{\mathrm{modified}} \]

where \( y \) is the IRR and \( N \) is the number of cash flows per year.

## ◆ convexity()

static Real convexity | ( | const Leg & | leg,
|  | const InterestRate & | yield,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

Cash-flow convexity.

The convexity of a string of cash flows is defined as

\[ C = \frac{1}{P} \frac{\partial^2 P}{\partial y^2} \]

where \( P \) is the present value of the cash flows according to the given IRR \( y \).

## ◆ basisPointValue()

static Real basisPointValue | ( | const Leg & | leg,
|  | const InterestRate & | yield,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

Basis-point value.

Obtained by setting dy = 0.0001 in the 2nd-order Taylor series expansion.

## ◆ yieldValueBasisPoint()

static Real yieldValueBasisPoint | ( | const Leg & | leg,
|  | const InterestRate & | yield,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

Yield value of a basis point.

The yield value of a one basis point change in price is the derivative of the yield with respect to the price multiplied by 0.01

## ◆ npv() [3/3]

static Real npv | ( | const Leg & | leg,
|  | const ext::shared_ptr< YieldTermStructure > & | discount,
|  | Spread | zSpread,
|  | const DayCounter & | dayCounter,
|  | Compounding | compounding,
|  | Frequency | frequency,
|  | bool | includeSettlementDateFlows,
|  | Date | settlementDate = `Date()`,
|  | Date | npvDate = `Date()`
| ) |  |
| static

NPV of the cash flows.

For details on z-spread refer to: "Credit Spreads Explained", Lehman Brothers European Fixed Income Research - March 2004, D. O'Kane

The NPV is the sum of the cash flows, each discounted according to the z-spreaded term structure. The result is affected by the choice of the z-spread compounding and the relative frequency and day counter.